PTLib Version 2.12.9

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Classes | Public Types | Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
PVideoDevice Class Referenceabstract

This class defines a video device. More...

`#include <videoio.h>`

Inheritance diagram for PVideoDevice:
[legend]
Collaboration diagram for PVideoDevice:
[legend]

## Classes
struct | Attributes
struct | OpenArgs

## Public Types
enum | VideoFormat { PAL, NTSC, SECAM, Auto, NumVideoFormats }
Public Types inherited from PVideoFrameInfo
enum | StandardSizes { SQCIFWidth = 128, SQCIFHeight = 96, QCIFWidth = 176, QCIFHeight = 144, CIFWidth = 352, CIFHeight = 288, CIF4Width = 704, CIF4Height = 576, CIF16Width = 1408, CIF16Height = 1152, HD480Width = 704, HD480Height = 480, i480Width = 704, i480Height = 480, HD720Width = 1280, HD720Height = 720, p720Width = 1280, p720Height = 720, HD1080Width = 1920, HD1080Height = 1080, i1080Width = 1920, i1080Height = 1080, HDTVWidth = 1920, HDTVHeight = 1080, MaxWidth = 1920, MaxHeight = 1200 }
Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...

## Public Member Functions
virtual | ~PVideoDevice ()
| Delete structures created by PVideoDevice();. More...
const PString & | GetDeviceName () const
| Get the device name of the open device. More...
virtual PStringArray | GetDeviceNames () const =0
| Get a list of all of the drivers available. More...
virtual PBoolean | OpenFull (const OpenArgs &args, PBoolean startImmediate=true)
| Open the device given the device name. More...
virtual PBoolean | Open (const PString &deviceName, PBoolean startImmediate=true)=0
| Open the device given the device name. More...
virtual PBoolean | IsOpen ()=0
| Determine if the device is currently open. More...
virtual PBoolean | Close ()=0
| Close the device. More...
virtual PBoolean | Start ()=0
| Start the video device I/O capture. More...
virtual PBoolean | Stop ()=0
| Stop the video device I/O capture. More...
virtual PBoolean | SetVideoFormat (VideoFormat videoFormat)
| Set the video format to be used. More...
virtual VideoFormat | GetVideoFormat () const
| Get the video format being used. More...
virtual int | GetNumChannels ()
| Get the number of video channels available on the device. More...
virtual PStringArray | GetChannelNames ()
| Get the names of video channels available on the device. More...
virtual PBoolean | SetChannel (int channelNumber)
| Set the video channel to be used on the device. More...
virtual int | GetChannel () const
| Get the video channel to be used on the device. More...
virtual bool | SetFrameInfoConverter (const PVideoFrameInfo &info)
| Set the frame info to be used, trying converters if available. More...
virtual PBoolean | SetColourFormatConverter (const PString &colourFormat)
| Set the colour format to be used, trying converters if available. More...
virtual PBoolean | GetVFlipState ()
| Get the video conversion vertical flip state. More...
virtual PBoolean | SetVFlipState (PBoolean newVFlipState)
| Set the video conversion vertical flip state. More...
virtual PBoolean | GetFrameSizeLimits (unsigned &minWidth, unsigned &minHeight, unsigned &maxWidth, unsigned &maxHeight)
| Get the minimum & maximum size of a frame on the device. More...
virtual PBoolean | SetFrameSizeConverter (unsigned width, unsigned height, ResizeMode resizeMode=eMaxResizeMode)
| Set the frame size to be used, trying converters if available. More...
virtual PBoolean | SetFrameSizeConverter (unsigned width, unsigned height, PBoolean)
| Set the frame size to be used, trying converters if available. More...
virtual PBoolean | SetNearestFrameSize (unsigned width, unsigned height)
| Set the nearest available frame size to be used. More...
virtual PBoolean | SetFrameSize (unsigned width, unsigned height)
| Set the frame size to be used. More...
virtual PBoolean | GetFrameSize (unsigned &width, unsigned &height) const
| Get the frame size being used. More...
virtual const PString & | GetColourFormat () const
| Get the colour format being used. More...
virtual PINDEX | GetMaxFrameBytes ()=0
| Get the maximum frame size in bytes. More...
int | GetLastError () const
| Get the last error code. More...
virtual PBoolean | CanCaptureVideo () const =0
| Is the device a camera, and obtain video. More...
virtual bool | GetAttributes (Attributes &attributes)
| Get video attributes. More...
virtual bool | SetAttributes (const Attributes &attributes)
| Set video attributes. More...
virtual PBoolean | SetVideoChannelFormat (int channelNumber, VideoFormat videoFormat)
| Set VideoFormat and VideoChannel in one ioctl. More...
void | SetPreferredColourFormat (const PString &colourFmt)
| Set preferred native colour format from video capture device. More...
const PString & | GetPreferredColourFormat ()
| Get preferred native colour format from video capture device. More...
Public Member Functions inherited from PVideoFrameInfo
| P_DECLARE_ENUM_EX (ResizeMode, eMaxResizeMode, eScale, 0, eCropCentre, eCropTopLeft)
| PVideoFrameInfo ()
| Construct video frame information. More...
| PVideoFrameInfo (unsigned frameWidth, unsigned frameHeight, const PString &colourFormat="YUV420P", unsigned frameRate=15, ResizeMode resizeMode=eScale)
virtual Comparison | Compare (const PObject &obj) const
| Compare the two PVideoFrameInfo and return their relative rank. More...
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
virtual unsigned | GetFrameWidth () const
| Get the width of the frame being used. More...
virtual unsigned | GetFrameHeight () const
| Get the height of the frame being used. More...
virtual PBoolean | SetFrameSar (unsigned width, unsigned height)
| Set the Storage Aspect Ratio size to be used. More...
virtual PBoolean | GetSarSize (unsigned &width, unsigned &height) const
| Get the Storage Aspect Ratio size being used. More...
virtual unsigned | GetSarWidth () const
| Get the width of the Storage Aspect Ratio being used. More...
virtual unsigned | GetSarHeight () const
| Get the height of the Storage Aspect Ratio being used. More...
virtual PBoolean | SetFrameRate (unsigned rate)
| Set the video frame rate to be used on the device. More...
virtual unsigned | GetFrameRate () const
| Get the video frame rate used on the device. More...
virtual PBoolean | SetColourFormat (const PString &colourFormat)
| Set the colour format to be used. More...
void | SetResizeMode (ResizeMode mode)
| Set the resize mode to be used. More...
ResizeMode | GetResizeMode () const
| Get the resize mode to be used. More...
PINDEX | CalculateFrameBytes () const
| Get the number of bytes of an image, given a particular width, height and colour format. More...
bool | Parse (const PString &str)
| Parse a descriptor string for the video format. More...
Public Member Functions inherited from PObject
unsigned | GetTraceContextIdentifier () const
| Get PTRACE context identifier. More...
void | SetTraceContextIdentifier (unsigned id)
void | GetTraceContextIdentifier (PObject &obj)
void | GetTraceContextIdentifier (PObject *obj)
void | SetTraceContextIdentifier (const PObject &obj)
void | SetTraceContextIdentifier (const PObject *obj)
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
template<class CLS >
CLS * | CloneAs () const
| As for Clone() but converts to specified type. More...
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
__inline const PObject * | PTraceObjectInstance () const
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Protected Member Functions
| PVideoDevice ()
| Create a new video device (input or output). More...
PINDEX | GetMaxFrameBytesConverted (PINDEX rawFrameBytes) const

## Protected Attributes
PCaselessString | deviceName
int | lastError
VideoFormat | videoFormat
int | channelNumber
PString | preferredColourFormat
PBoolean | nativeVerticalFlip
PColourConverter * | converter
PBYTEArray | frameStore
Protected Attributes inherited from PVideoFrameInfo
unsigned | frameWidth
unsigned | frameHeight
unsigned | sarWidth
unsigned | sarHeight
unsigned | frameRate
PString | colourFormat
ResizeMode | resizeMode
Protected Attributes inherited from PObject
unsigned | m_traceContextIdentifier

## Additional Inherited Members
Static Public Member Functions inherited from PVideoFrameInfo
static PINDEX | CalculateFrameBytes (unsigned width, unsigned height, const PString &colourFormat)
static bool | ParseSize (const PString &str, unsigned &width, unsigned &height)
| Parse the standard size string names. More...
static PString | AsString (unsigned width, unsigned height)
| Get a width/height as a standard size string name. More...
static PStringArray | GetSizeNames ()
| Get all "known" image size names. More...
Friends inherited from PObject

## Detailed Description

This class defines a video device.

This class is used to abstract the few parameters that are common to both\ input and output devices.

Example colour formats are:

"Grey" Simple 8 bit linear grey scale "Gray" Synonym for Grey "RGB32" 32 bit RGB "RGB24" 24 bit RGB "RGB565" 16 bit RGB (6 bit green) "RGB555" 15 bit RGB "YUV422" YUV 4:2:2 packed "YUV422P" YUV 4:2:2 planar "YUV411" YUV 4:1:1 packed "YUV411P" YUV 4:1:1 planar "YUV420" YUV 4:2:0 packed "YUV420P" YUV 4:2:0 planar "YUV410" YUV 4:1:0 packed "YUV410P" YUV 4:1:0 planar "MJPEG" Motion JPEG "UYVY422" YUV 4:2:2 packed as U Y V Y U Y V Y ... "UYV444" YUV 4:4:4 packed as U Y V U Y V ... They are used in IEEE 1394 digital cameras. The specification is found at http://www.1394ta.org/Download/Technology/Specifications/2000/IIDC_Spec_v1_30.pdf

## Member Enumeration Documentation

enum PVideoDevice::VideoFormat

Enumerator
PAL |
NTSC |
SECAM |
Auto |
NumVideoFormats |

## Constructor & Destructor Documentation

PVideoDevice::PVideoDevice | ( |  | ) |
| protected

Create a new video device (input or output).

virtual PVideoDevice::~PVideoDevice | ( |  | ) |
| virtual

Delete structures created by PVideoDevice();.

## Member Function Documentation

virtual PBoolean PVideoDevice::CanCaptureVideo | ( |  | ) | const
| pure virtual

Is the device a camera, and obtain video.

Implemented in PVideoInputDevice, and PVideoOutputDevice.

virtual PBoolean PVideoDevice::Close | ( |  | ) |
| pure virtual

Close the device.

Implemented in PVideoInputDevice, PVideoOutputDevice, and PVideoInput1394DcDevice.

virtual bool PVideoDevice::GetAttributes | ( | Attributes & | attributes | ) |
| virtual

Get video attributes.

virtual int PVideoDevice::GetChannel | ( |  | ) | const
| virtual

Get the video channel to be used on the device.

Default behaviour returns the value of the channelNumber variable.

virtual PStringArray PVideoDevice::GetChannelNames | ( |  | ) |
| virtual

Get the names of video channels available on the device.

virtual const PString& PVideoDevice::GetColourFormat | ( |  | ) | const
| virtual

Get the colour format being used.

If a converter exists, the destination colour format of the converter is returned, not the underlying physical device. If you wish the physical device colout format use PVideoFrameInfo::GetColourFormat().

Reimplemented from PVideoFrameInfo.

const PString& PVideoDevice::GetDeviceName | ( |  | ) | const
| inline

Get the device name of the open device.

References deviceName.

Referenced by PVideoInputDevice::GetDeviceCapabilities().

virtual PStringArray PVideoDevice::GetDeviceNames | ( |  | ) | const
| pure virtual

Get a list of all of the drivers available.

virtual PBoolean PVideoDevice::GetFrameSize | ( | unsigned & | width,
|  | unsigned & | height
| ) |  | const
| virtual

Get the frame size being used.

If a converter exists, the destination frame size of the converter is returned, not the underlying physical device. If you wish the physical device frame size use PVideoFrameInfo::GetFrameSize().

Reimplemented from PVideoFrameInfo.

virtual PBoolean PVideoDevice::GetFrameSizeLimits | ( | unsigned & | minWidth,
|  | unsigned & | minHeight,
|  | unsigned & | maxWidth,
|  | unsigned & | maxHeight
| ) |  |
| virtual

Get the minimum & maximum size of a frame on the device.

Default behaviour returns the value 1 to UINT_MAX for both and returns false.

Parameters

  minWidth | Variable to receive minimum width
  minHeight | Variable to receive minimum height
  maxWidth | Variable to receive maximum width
  maxHeight | Variable to receive maximum height

Reimplemented in PVideoInput1394DcDevice.

int PVideoDevice::GetLastError | ( |  | ) | const
| inline

Get the last error code.

This is a platform dependent number.

References lastError.

virtual PINDEX PVideoDevice::GetMaxFrameBytes | ( |  | ) |
| pure virtual

Get the maximum frame size in bytes.

This gets the maximum of the physical device or the converted frame size and colour format. It is guranteed to be enought memory space for any video grab or output.

Note, a particular device may be able to provide variable length frames (eg motion JPEG) so this will be the maximum size of all frames.

Implemented in PVideoOutputDeviceRGB, and PVideoInput1394DcDevice.

PINDEX PVideoDevice::GetMaxFrameBytesConverted | ( | PINDEX | rawFrameBytes | ) | const
| protected

virtual int PVideoDevice::GetNumChannels | ( |  | ) |
| virtual

Get the number of video channels available on the device.

Default behaviour returns 1.

Reimplemented in PVideoInput1394DcDevice.

const PString& PVideoDevice::GetPreferredColourFormat | ( |  | ) |
| inline

Get preferred native colour format from video capture device.

Returns empty == no preference

References preferredColourFormat.

virtual PBoolean PVideoDevice::GetVFlipState | ( |  | ) |
| virtual

Get the video conversion vertical flip state.

Default action is to return false.

virtual VideoFormat PVideoDevice::GetVideoFormat | ( |  | ) | const
| virtual

Get the video format being used.

Default behaviour returns the value of the videoFormat variable.

virtual PBoolean PVideoDevice::IsOpen | ( |  | ) |
| pure virtual

Determine if the device is currently open.

Implemented in PVideoInput1394DcDevice.

virtual PBoolean PVideoDevice::Open | ( | const PString & | deviceName,
|  | PBoolean | startImmediate = `true`
| ) |  |
| pure virtual

Open the device given the device name.

Parameters

  deviceName | Device name to open
  startImmediate | Immediately start device

Implemented in PVideoInputDevice, and PVideoInput1394DcDevice.

virtual PBoolean PVideoDevice::OpenFull | ( | const OpenArgs & | args,
|  | PBoolean | startImmediate = `true`
| ) |  |
| virtual

Open the device given the device name.

Parameters

  args | Parameters to set on opened device
  startImmediate | Immediately start device

virtual bool PVideoDevice::SetAttributes | ( | const Attributes & | attributes | ) |
| virtual

Set video attributes.

virtual PBoolean PVideoDevice::SetChannel | ( | int | channelNumber | ) |
| virtual

Set the video channel to be used on the device.

The channel number is an integer from 0 to GetNumChannels()-1. The special value of -1 will find the first working channel number.

Default behaviour sets the value of the channelNumber variable and then returns true.

Parameters

  channelNumber | New channel number for device.

Reimplemented in PVideoInput1394DcDevice.

virtual PBoolean PVideoDevice::SetColourFormatConverter | ( | const PString & | colourFormat | ) |
| virtual

Set the colour format to be used, trying converters if available.

This function will set the colour format on the device to one that is compatible with a registered converter, and install that converter so that the correct format is used.

Reimplemented in PVideoInput1394DcDevice.

virtual bool PVideoDevice::SetFrameInfoConverter | ( | const PVideoFrameInfo & | info | ) |
| virtual

Set the frame info to be used, trying converters if available.

This function will simply call SetColourFormatConverter(), SetFrameSizeConverter() and SetFrameRate().

virtual PBoolean PVideoDevice::SetFrameSize | ( | unsigned | width,
|  | unsigned | height
| ) |  |
| virtual

Set the frame size to be used.

Note that devices may not be able to produce the requested size, and this function will fail. See SetFrameSizeConverter().

Default behaviour sets the frameWidth and frameHeight variables and then sets the converter sizes.

Parameters

  width | New width of frame
  height | New height of frame

Reimplemented from PVideoFrameInfo.

Reimplemented in PVideoOutputDeviceRGB, and PVideoInput1394DcDevice.

virtual PBoolean PVideoDevice::SetFrameSizeConverter | ( | unsigned | width,
|  | unsigned | height,
|  | ResizeMode | resizeMode = `eMaxResizeMode`
| ) |  |
| virtual

Set the frame size to be used, trying converters if available.

If the device does not support the size, a set of alternate resolutions are attempted. A converter is setup if possible.

Parameters

  width | New width of frame
  height | New height of frame
  resizeMode | Mode to use if resizing is required.

virtual PBoolean PVideoDevice::SetFrameSizeConverter | ( | unsigned | width,
|  | unsigned | height,
|  | PBoolean |
| ) |  |
| inline virtual

Set the frame size to be used, trying converters if available.

Function used for Backward compatibility only. If the device does not support the size, a set of alternate resolutions are attempted. A converter is setup if possible.

Parameters

  width | New width of frame
  height | New height of frame

Reimplemented in PVideoInput1394DcDevice.

References SetFrameSizeConverter().

Referenced by SetFrameSizeConverter().

virtual PBoolean PVideoDevice::SetNearestFrameSize | ( | unsigned | width,
|  | unsigned | height
| ) |  |
| virtual

Set the nearest available frame size to be used.

Note that devices may not be able to produce the requested size, so this function picks the nearest available size.

Default behaviour simply calls SetFrameSize().

Parameters

  width | New width of frame
  height | New height of frame

Reimplemented in PVideoInputDevice.

void PVideoDevice::SetPreferredColourFormat | ( | const PString & | colourFmt | ) |
| inline

Set preferred native colour format from video capture device.

Note empty == no preference.

References preferredColourFormat.

virtual PBoolean PVideoDevice::SetVFlipState | ( | PBoolean | newVFlipState | ) |
| virtual

Set the video conversion vertical flip state.

Default action is to return false.

Parameters

  newVFlipState | New vertical flip state

virtual PBoolean PVideoDevice::SetVideoChannelFormat | ( | int | channelNumber,
|  | VideoFormat | videoFormat
| ) |  |
| virtual

Set VideoFormat and VideoChannel in one ioctl.

virtual PBoolean PVideoDevice::SetVideoFormat | ( | VideoFormat | videoFormat | ) |
| virtual

Set the video format to be used.

Default behaviour sets the value of the videoFormat variable and then returns true.

Parameters

  videoFormat | New video format

Reimplemented in PVideoInput1394DcDevice.

virtual PBoolean PVideoDevice::Start | ( |  | ) |
| pure virtual

Start the video device I/O capture.

Implemented in PVideoOutputDevice, and PVideoInput1394DcDevice.

virtual PBoolean PVideoDevice::Stop | ( |  | ) |
| pure virtual

Stop the video device I/O capture.

Implemented in PVideoOutputDevice, and PVideoInput1394DcDevice.

## Member Data Documentation

int PVideoDevice::channelNumber
| protected

PColourConverter* PVideoDevice::converter
| protected

PCaselessString PVideoDevice::deviceName
| protected

Referenced by GetDeviceName().

PBYTEArray PVideoDevice::frameStore
| protected

int PVideoDevice::lastError
| protected

Referenced by GetLastError().

PBoolean PVideoDevice::nativeVerticalFlip
| protected

PString PVideoDevice::preferredColourFormat
| protected

Referenced by GetPreferredColourFormat(), and SetPreferredColourFormat().

VideoFormat PVideoDevice::videoFormat
| protected

The documentation for this class was generated from the following file:

- videoio.h